<?php
/**
*
* @package Last X [attachments] on Viewtopic v.0.0.4
* @version $Id: last_x_attachments_on_viewtopic_crawl.php 2011-1-09 15:20:35Z 4seven $
* @copyright (c) 2011 / 4seven
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

if (!defined('IN_PHPBB'))
{
	exit;
}

// Last X [attachments] on Viewtopic / 4seven / 2011

//---------SETTINGS----------
//----------------------------------
// here u can enter the foren id's to show
$forum_ids_to_show = '7,10,15';
// enter as given: '7,9,10'
//----------------------------------
// make the setting, if you desired width or height here
$width_o_height = 'height';
// i find height more attractiv ;)
//----------------------------------
// crawl script or not 
$crawl_o_not = 'yes';
// enter as given 'yes' or 'no'
//---------------------------------- 
// detect screen resolution  of user via java
// (if anything is disfunction by detection, turn it to: no)
$detect_java_screen  = 'no';
// enter as given yes or no.
//----------------------------------
// number of max pics to show 
// (important if user have no javacript  enabled or $detect_java_screen  is set to 'no';)
$max_pic_to_show  = 10;
// enter as given 9 or 12 etc.
//----------------------------------
// make the setting of max px here (counts for width or height)
$convert_mx_size = 100;
// don't make it to big
//---------SETTINGS---------

if ($detect_java_screen == 'yes'){

if (!request_var('w', '', true)){

echo "<script language='javascript'>\n";
echo "  location.href=\"${_SERVER['SCRIPT_NAME']}?${_SERVER['QUERY_STRING']}"
 . "&w=\" + screen.width + \"&h=\" + screen.height;\n";
echo "</script>\n"; 

$convert_real_size = $max_pic_to_show;

$template->assign_vars(array(
'NUMBER_OF_SHOWN_ATTACH' => $convert_real_size));}

else if (request_var('w', '', true)){

if ($width_o_height == 'width'){
if ($crawl_o_not == 'no'){
$convert_real_size = round(request_var('w', '') / ($convert_mx_size*1.3));}
else{
$convert_real_size = round(request_var('w', '') / ($convert_mx_size*0.65));}
}
else{
if ($crawl_o_not == 'no'){
$convert_real_size = round(request_var('w', '') / ($convert_mx_size*1.8));}
else{
$convert_real_size = round(request_var('w', '') / ($convert_mx_size*0.9));}
}

$template->assign_vars(array(
'S_NO_JAVA_PRESENT'      => request_var('w', '', true),
'NUMBER_OF_SHOWN_ATTACH' => $convert_real_size,
'SCREEN_WIDTH'           => request_var('w', ''),
'SCREEN_HEIGHT'          => request_var('h', '')));
}

$template->assign_vars(array(
'S_NO_JAVA_DETECTION'    => true
));}

else{
$convert_real_size = $max_pic_to_show;

$template->assign_vars(array(
'NUMBER_OF_SHOWN_ATTACH' => $convert_real_size,
'S_NO_JAVA_DETECTION'    => false
));}

$forums = ($forum_ids_to_show) ? $forum_ids_to_show : 0;

$forum_ary = array();
$forum_read_ary = $auth->acl_getf('f_read');

foreach ($forum_read_ary as $forum_ids => $allowed){
if ($allowed['f_read']){
$forum_ary[] = (int) $forum_ids;}}

$forum_ary = array_intersect(array_keys($auth->acl_getf('f_read', true)), array_keys($auth->acl_getf('f_download', true)));

if (!empty($forum_ary)){

$sqls = 'SELECT a.attach_id, a.topic_id, a.post_msg_id, a.physical_filename, a.real_filename, f.forum_id, t.topic_id, t.forum_id, t.topic_title
		FROM ' . ATTACHMENTS_TABLE . ' a, ' . FORUMS_TABLE . ' f, ' . TOPICS_TABLE . ' t 
		WHERE (mimetype = "image/jpeg" OR mimetype = "image/png" OR mimetype = "image/gif")
		AND a.is_orphan = 0
		AND a.topic_id = ' . $topic_id . '
		AND t.topic_id = ' . $topic_id . '
		AND ' . $db->sql_in_set('t.forum_id', $forum_ary) . '
		AND t.forum_id IN (' . $forums . ')		
		GROUP BY attach_id DESC';		
$results = $db->sql_query_limit($sqls, $convert_real_size);

while ($rows = $db->sql_fetchrow($results)){

if ($rows){
$template->assign_vars(array(
'S_NO_ATT_TO_SHOW'  => true
));}
	
if (!file_exists($phpbb_root_path . 'images/last_x_att/' . $rows['physical_filename'] . substr(strtolower($rows['real_filename']), -4))){
if (!empty($rows['physical_filename']) && @getimagesize($phpbb_root_path . 'files/' . $rows['physical_filename'])){

$convert_only_size = getimagesize($phpbb_root_path . 'files/' . $rows['physical_filename']);

if ($width_o_height == 'width'){
$convert_only_sizing = $convert_only_size[0];}
else{
$convert_only_sizing = $convert_only_size[1];}

if (($convert_only_size[0] >= $convert_mx_size) && ($convert_only_size[1] >= $convert_mx_size)){	

if (!function_exists('simpleresize')) {
include_once($phpbb_root_path . 'includes/thumb_resize.' . $phpEx);}

$image = new simpleresize();
$image->load('files/' . $rows['physical_filename']);
if ($width_o_height  == 'width'){
$image->resizeToWidth($convert_mx_size);}
else{
$image->resizeToHeight($convert_mx_size);}
$image->save($phpbb_root_path . 'images/last_x_att/' . $rows['physical_filename'] . substr(strtolower($rows['real_filename']), -4));}

}}

$template->assign_block_vars('forum_pics', array(
	  'S_2_SMALL'	  => file_exists($phpbb_root_path . 'images/last_x_att/' . $rows['physical_filename'] . substr(strtolower($rows['real_filename']), -4)) ? true : false,
      'TOPIC_IDEE'    => append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'p=' . $rows['post_msg_id']) . '#p' . $rows['post_msg_id'],	  
      'ATTACH_IDEE'	  => append_sid("{$phpbb_root_path}download/file.$phpEx", 'id=' . $rows['attach_id']),	
      'TOPIC_TIITLEE' => censor_text($rows['topic_title']),
      'ATTACH_TEST'   => $phpbb_root_path . 'images/last_x_att/' . $rows['physical_filename'] . substr(strtolower($rows['real_filename']), -4)));

$count_attach_ids[] = $rows['attach_id'];

}

if (isset($count_attach_ids)){
$count_attach_num = sizeof($count_attach_ids);

$template->assign_vars(array(
'S_ATTACH_TES'        => ($count_attach_num <= 3) ? true : false 
));
}


$db->sql_freeresult($results);


}

// Last X [attachments] on Viewtopic / 4seven / 2011

?>